// C Source File
// Created 01.04.2006; 11:53:34

 /********************************************************************************
 ********************************************************************************
 * Programm name:		thedb - The handy education database
 * File name:				check_if_in_use_bit_set.c
 * Function name:		check_if_in_use_bit_set
 * Header file:			---
 * Other functions:
 *	-
 *
 * Short Description: Check if the in-use-bit (hidden-bit) of a file is set
 *
 * Description:
 *	-
 *
 ********************************************************************************
 *********************************************************************************/

#include <tigcclib.h>
#include "fmanage.h"

#include "structures.h"
#include "global.h"

int check_if_in_use_bit_set (int no_message)
{
	if (no_message == 0)
		{
			GrayOff();
			clrscr();
		}


	SYM_ENTRY *sym = SymFindPtr(SYMSTR(ActivePath), 0);
	if (sym == NULL)
		{
			if (no_message == 0)
				DlgMessage("thedb[40]", "Active file not found!", BT_OK, BT_CANCEL);
			return -1;
		}
	else
		{
			if (sym->flags.bits.hidden == 1)
				{
					if (no_message == 0)
						DlgMessage("thedb[42]", "The active file is hidden (in-use-bit set)!", BT_OK, BT_CANCEL);
					return -1;
				}
		}

	return 0;
}
