// C Source File
// Created 18.02.2006; 14:38:34

 /********************************************************************************
 ********************************************************************************
 * Programm name:		thedb - The handy education database
 * File name:				create_new_file.c
 * Function name:		create_new_file
 * Header file:			---
 * Other functions:
 *	-
 *
 * Short Description: Show the dialog box to enter a filename for a new file
 *
 * Description:
 *	-
 *
 ********************************************************************************
 *********************************************************************************/

#include <tigcclib.h>
#include "fmanage.h"

#include "structures.h"
#include "global.h"
#include "calc.h"


int create_new_file (CONFSTRUCT *confstruct)
{
	SYM_ENTRY *SymPtr = NULL;
	HANDLE dialog;
	HANDLE pdown;

	FILE *datafile = NULL;		//The file pointer that handles the data file

	char buffer[10] = {0};
	int pdown_choice = 1;
	int count = 0;
	char ext[5] ={0};
	char str[80] = {0};
	char Path[PATH_LENGHT] = {0};

		dialog = DialogNewSimple (130, 50);
		pdown = PopupNew ("" , 0);

			//Add the dialog title
			DialogAddTitle(dialog, "New file", BT_SAVE, BT_CANCEL);


			//Write a folder list in the pulldown menu
			count = 1;
			SymPtr = SymFindFirst(NULL, FO_SKIP_TEMPS);
			while (SymPtr)
			{
			  PopupAddText(pdown, -1, SymPtr->name, count);
			  SymPtr = SymFindNext();
			  count++;
			}
				//-> VarCreateFolderPopup ???

			DialogAddPulldown(dialog, 2, 15, "Folder:", pdown, 0);
			DialogAddRequest(dialog, 3, 25, "Filename:", 0, 8, 10);

	GrayOff();
	clrscr();

		while (1)
			{
				if ((DialogDo(dialog, CENTER, CENTER, buffer, &pdown_choice)) == KEY_ENTER)
					{
						//Check if buffer is empty
						if (strlen(buffer) < 1)
							{
								//Archive the active file
								archive_active_file(confstruct);
								//Set the corresponding path to default
								switch (confstruct->ActiveForm)
									{
										case FORM_FORMULA:
												memset(confstruct->PathFormula[confstruct->ActivePathFormula], 0, sizeof(confstruct->PathFormula[confstruct->ActivePathFormula]));
												strcpy(confstruct->PathFormula[confstruct->ActivePathFormula], STR_NO_FILE_SEL);
												strcpy(ActivePath, confstruct->PathFormula[confstruct->ActivePathFormula]);
											break;
										case FORM_TEXT:
												memset(confstruct->PathText[confstruct->ActivePathText], 0, sizeof(confstruct->PathText[confstruct->ActivePathText]));
												strcpy(confstruct->PathText[confstruct->ActivePathText], STR_NO_FILE_SEL);
												strcpy(ActivePath, confstruct->PathText[confstruct->ActivePathText]);
											break;
										default:
											break;
									}
								return 0;
							}


						//Check if the first letter is a number
						if ((isdigit(buffer[0])) != 0)
							{
								DlgMessage("thedb[5]", "The first letter can't be a number!", BT_OK, BT_NONE);
								continue;
							}


						if (CheckReservedName(SYMSTR(buffer)) != 0)		//CheckReservedName needs just the filename and not a path
							{
								DlgMessage("thedb[35]", "Reserved filename!", BT_OK, BT_CANCEL);
								continue;
							}
							
						if (FAccess(buffer, FM_WRITE_ACCESS, "test") == FS_BAD_NAME)		//FAccess needs just the filename and not a path
							{
								DlgMessage("thedb[45]", "Invalid filename!", BT_OK, BT_CANCEL);
								continue;
							}

						//Put the pathname together
						//Go through the folder list and copy the folder selected with pdown_choice
						count = 1;
						SymPtr = SymFindFirst(NULL, FO_SKIP_TEMPS);
						while (SymPtr)
							{
							  if (count++ == pdown_choice)
							  	{
										strcat(Path, SymPtr->name);
							  	}
							  SymPtr = SymFindNext();
							}

						//Add the \ and the file name.
						strcat(Path, "\\");
						strncat(Path, buffer, 8);

						//Check if the file already exists
						HSym hs = SymFind(SYMSTR(Path));
						if (hs.folder != 0)
							{
								//Check file extension
								FType(Path, ext);

								//If the file extension is the one for formula files
								if (strcmp(ext, FILE_FORMULA_EXTENSION) == 0)
									{
										if ((DlgMessage("thedb[27]", "File already exists as formula file!\nOverwrite?", BT_OK, BT_CANCEL)) == KEY_ESC)
											continue;
									}
								//If the file extension is the one for text files
								else if (strcmp(ext, FILE_TEXT_EXTENSION) == 0)
									{
										if ((DlgMessage("thedb[28]", "File already exists as text file!\nOverwrite?", BT_OK, BT_CANCEL)) == KEY_ESC)
											continue;
									}
								else
									{
										sprintf(str, "File already exists as *.%s file!\nOverwrite %s.%s?", ext, Path, ext);
										if ((DlgMessage("thedb[29]", str, BT_OK, BT_CANCEL)) == KEY_ESC)
											continue;
									}

							}

						memset(ActivePath, 0, sizeof(ActivePath));
						//Try to open the file or create a new one.
						switch (confstruct->ActiveForm)
							{
								case FORM_FORMULA:
										if ((fmanage(&datafile, Path, FMF_FORMULA_FILE_VERSION, FILE_FORMULA_EXTENSION, NULL, sizeof(FORMULADATA), 0, FMF_NEW_FILE, FMF_NEW_OVERWR | FMF_CLOSE)) < 0)
											{
												DlgMessage("thedb[30]", "Failed to create!", BT_OK, BT_NONE);
												continue;
											}
										memset(confstruct->PathFormula[confstruct->ActivePathFormula], 0, sizeof(confstruct->PathFormula[confstruct->ActivePathFormula]));
										strcpy(confstruct->PathFormula[confstruct->ActivePathFormula], Path);
										strcpy(ActivePath, confstruct->PathFormula[confstruct->ActivePathFormula]);
									break;
								case FORM_TEXT:
										if ((fmanage(&datafile, Path, FMF_TEXT_FILE_VERSION, FILE_TEXT_EXTENSION, NULL, sizeof(TEXTDATA), 0, FMF_NEW_FILE, FMF_NEW_OVERWR | FMF_CLOSE)) < 0)
											{
												DlgMessage("thedb[31]", "Failed to create!", BT_OK, BT_NONE);
												continue;
											}
										memset(confstruct->PathText[confstruct->ActivePathText], 0, sizeof(confstruct->PathText[confstruct->ActivePathText]));
										strcpy(confstruct->PathText[confstruct->ActivePathText], Path);
										strcpy(ActivePath, confstruct->PathText[confstruct->ActivePathText]);
									break;
								default:
									break;
							}
					}
				else
					{
						return -1;
					}

				break;
			};



	HeapFree(dialog);
	HeapFree(pdown);

	return 0;
}