// C Source File
// Created 17.02.2006; 19:57:29

 /********************************************************************************
 ********************************************************************************
 * Programm name:		thedb - The handy education database
 * File name:				main_menu.c
 * Function name:		main_menu
 * Header file:			main_menu.h
 *
 * Short Description:	Show the main menu grafics - show the menu - check out key input
 *
 * Description:
 *	- Check the position of the cursor and set it to default, if something is wrong
 *	- Show the borders, the title and the footer of the main menu
 *	- Show the menu points
 *	- Update the info section (the left side with the "Active file")
 *	- start the key input control
 *
 ********************************************************************************
 *********************************************************************************/

#include <tigcclib.h>

#include "structures.h"
#include "global.h"
#include "calc.h"
#include "main_menu.h"

//

//


void main_menu (CONFSTRUCT *confstruct, int action)
{
	int CursorPosY;
	int ActiveMenu;

	if (ActiveMenu != MM_MAIN || MM_INFO)
		ActiveMenu = MM_MAIN;

	if (CursorPosY != MM_MENU0 || MM_MENU1 || MM_MENU2 || MM_MENU3 || MM_MENU4 || MM_MENU5 || MM_INFO_ACTIVE_FILE || MM_INFO_AUTOSTART)
		CursorPosY = MM_MENU0;

	if (action == 1)
		{	//Reset cursor positions
			CursorPosY = MM_MENU0;
			ActiveMenu = MM_MAIN;
		}

	//Check the cursor positions
	if (ActiveMenu == MM_INFO)
		{
			if ((CursorPosY > MM_INFO_AUTOSTART) || ((CursorPosY < MM_INFO_ACTIVE_FILE)))
				CursorPosY = MM_INFO_ACTIVE_FILE;
		}
	else
		{
			ActiveMenu = MM_MAIN;
			if ((CursorPosY > MM_MENU5) || ((CursorPosY < MM_MENU0)))
				CursorPosY = MM_MENU0;
		}

			//Choose, depending on the settings, if the autostart option is enabled and start the corresponding part
			if (confstruct->Startup == S_STARTUP_LIST)
				{
					main_menu_show_info(confstruct, 1);
					while ((list_data(confstruct)) == 1);
				}

	do
		{
			main_menu_graphic();

			//the menu (light plane)
			GraySetAMSPlane (LIGHT_PLANE);
			DrawChar(2, MM_MENU0, 0x12, A_NORMAL);
			DrawChar(52, MM_MENU0, 0x11, A_NORMAL);
			main_menu_set_form(confstruct);


			DrawChar(2, MM_MENU1, 0x12, A_NORMAL);
			DrawChar(52, MM_MENU1, 0x11, A_NORMAL);
			DrawStr(8, MM_MENU1, "Show", A_NORMAL);

			DrawChar(2, MM_MENU2, 0x12, A_NORMAL);
			DrawChar(52, MM_MENU2, 0x11, A_NORMAL);
			DrawStr(8, MM_MENU2, "New", A_NORMAL);

			DrawChar(2, MM_MENU3, 0x12, A_NORMAL);
			DrawChar(52, MM_MENU3, 0x11, A_NORMAL);
			DrawStr(8, MM_MENU3, "Settings", A_NORMAL);

			DrawChar(2, MM_MENU4, 0x12, A_NORMAL);
			DrawChar(52, MM_MENU4, 0x11, A_NORMAL);
			DrawStr(8, MM_MENU4, "About...", A_NORMAL);

			DrawChar(2, MM_MENU5, 0x12, A_NORMAL);
			DrawChar(52, MM_MENU5, 0x11, A_NORMAL);
			DrawStr(8, MM_MENU5, "Exit", A_NORMAL);

			//Set infos
			DrawStr(62, MM_INFO_ACTIVE_FILE - 8, "Active file:", A_NORMAL);
			DrawChar(64, MM_INFO_ACTIVE_FILE, 0x12, A_NORMAL);
			DrawChar(LCD_WIDTH - 8, MM_INFO_ACTIVE_FILE, 0x11, A_NORMAL);


			//DrawStr(62, MM_INFO_AUTOSTART - 8, "Set for autostart:", A_NORMAL);
			DrawChar(64, MM_INFO_AUTOSTART, 0x12, A_NORMAL);
			DrawChar(LCD_WIDTH - 8, MM_INFO_AUTOSTART, 0x11, A_NORMAL);

			//DrawStr(62, MM_INFO_ENTRIES - 8, "Entries:", A_NORMAL);
			//DrawChar(64, MM_INFO_ENTRIES, 0x12, A_NORMAL);
			//DrawChar(LCD_WIDTH - 8, MM_INFO_ENTRIES, 0x11, A_NORMAL);

			//the menu (dark plane)
			GraySetAMSPlane (DARK_PLANE);
			DrawStr(8, MM_MENU1, "Show", A_NORMAL);
			DrawStr(8, MM_MENU2, "New", A_NORMAL);
			DrawStr(8, MM_MENU3, "Settings", A_NORMAL);
			DrawStr(8, MM_MENU4, "About...", A_NORMAL);
			DrawStr(8, MM_MENU5, "Exit", A_NORMAL);

			DrawStr(62, MM_INFO_ACTIVE_FILE - 8, "Active file:", A_NORMAL);
			//DrawStr(62,  MM_INFO_AUTOSTART - 8, "Set for autostart:", A_NORMAL);
			//DrawStr(62, MM_INFO_ENTRIES - 8, "Entries:", A_NORMAL);

			main_menu_show_info(confstruct, 0);


		} while ((main_menu_control(confstruct, &ActiveMenu, &CursorPosY)) == 1);


	GrayOff();


}







