// C Source File
// Created 18.02.2006; 14:04:16

 /********************************************************************************
 ********************************************************************************
 * Programm name:		thedb - The handy education database
 * File name:				new_entry_formula.c
 * Function name:		new_entry_formula
 * Header file:			---
 * Other functions:
 *	-
 *
 * Short Description: Show the dialog box to enter data for a new formula entry
 *
 * Description:
 *	-
 *
 ********************************************************************************
 *********************************************************************************/

#include <tigcclib.h>
#include "fmanage.h"

#include "structures.h"
#include "global.h"
#include "calc.h"

int new_entry_formula (CONFSTRUCT *confstruct, int action, int datanr)
{
	FILE *datafile = NULL;						//The file pointer that handles the data file
	FORMULADATA datastruct;					//The structure which will be added to the file at the end
	char buffer[MAXLEN_NAME + 1 + MAXLEN_FORMULA + 1 + MAXLEN_DESC + 2] = {0};
	char *tempbuffer;
	char titlestr[30] = {0};
	long int NumberOfBlocks = 0;

	GrayOff();
	clrscr();

	//Create a new file, if the path name is the default string
	if (strstr(ActivePath, STR_NO_FILE_SEL) != NULL)
		{
			if ((create_new_file(confstruct)) == -1)
				return -1;
		}

	if (check_if_in_use_bit_set(0) == -1)
		return -1;

	if ((check_file_validity(confstruct, ActivePath, 1)) == 0)
		return -1;

	/*Allocate memory for the structure
	if ((datastruct = malloc(sizeof(FORMULADATA))) == NULL)
		{
			DlgMessage("thedb[3]", "Memory!", BT_OK, BT_CANCEL);
			return -1;
		}
	*/

	//Try to open the file. If it fails, create it.
	if ((fmanage(&datafile, ActivePath, FMF_FORMULA_FILE_VERSION, FILE_FORMULA_EXTENSION, &datastruct, sizeof(FORMULADATA), 0, FMF_NEW_FILE, FMF_NEW_NO_OVERWR)) < 0)
		{
			free(&datastruct);
			return -1;
		}

	if ((check_if_file_is_locked(datafile)) == -1)
		return -1;

	//Load the number of Blocks in the file.
	NumberOfBlocks = fmanage(&datafile, NULL, 0, NULL, NULL, 0, 0, FMF_RETURN_FINFO, FMF_RETURN_NOB);


	if (action == FMF_EDIT)
		{
			//Load data
			fmanage(&datafile, ActivePath, FMF_FORMULA_FILE_VERSION, FILE_FORMULA_EXTENSION, &datastruct, sizeof(FORMULADATA), datanr, FMF_LOAD, 0);

			sprintf (titlestr, "Edit formula [%03d]" , datanr);
			tempbuffer = buffer;
			strcpy (tempbuffer, datastruct.name);
				tempbuffer += MAXLEN_NAME + 1;
			strcat (tempbuffer, datastruct.formula);
				tempbuffer += MAXLEN_FORMULA + 1;
			strcat (tempbuffer, datastruct.desc);
		}
	else
		{
			sprintf (titlestr, "New formula [%03ld]" , NumberOfBlocks + 1);
			datanr = 0;
		}


#ifdef THDB_DEBUG
			sprintf(datastruct.name, "Name %ld", NumberOfBlocks + 1);
			sprintf(datastruct.formula, "Formula %ld", NumberOfBlocks + 1);
			sprintf(datastruct.desc, "Description %ld", NumberOfBlocks + 1);

			tempbuffer = buffer;
			strcpy (tempbuffer, datastruct.name);
				tempbuffer += MAXLEN_NAME + 1;
			strcat (tempbuffer, datastruct.formula);
				tempbuffer += MAXLEN_FORMULA + 1;
			strcat (tempbuffer, datastruct.desc);
#endif

	HANDLE dialog = DialogNewSimple (LCD_WIDTH - 5, 90);

#ifndef THDB_AUTOSAVE
		DialogAddTitle (dialog, titlestr, BT_SAVE, BT_CANCEL);
		DialogAddText(dialog, 1, 15, "Name:");
		DialogAddRequest (dialog, 2, 25, "" , 0, MAXLEN_NAME, 22 + DLG_ADJ);
		DialogAddText(dialog, 1, 35, "Formula:");
		DialogAddRequest (dialog, 2, 45, "" , MAXLEN_NAME + 1, MAXLEN_FORMULA, 22 + DLG_ADJ);
		DialogAddText(dialog, 1, 55, "Description:");
		DialogAddRequest (dialog, 2, 65, "", MAXLEN_NAME + 1 + MAXLEN_FORMULA + 1, MAXLEN_DESC, 22 + DLG_ADJ);

		if ((DialogDo (dialog, CENTER, CENTER, buffer, NULL)) == KEY_ENTER)
			{
#endif
				tempbuffer = buffer;
					strcpy (datastruct.name, tempbuffer);
				tempbuffer += MAXLEN_NAME + 1;
					strcpy (datastruct.formula, tempbuffer);
				tempbuffer += MAXLEN_FORMULA + 1;
					strcpy (datastruct.desc, tempbuffer);
#ifndef THDB_AUTOSAVE
			}
		else
			{
				HeapFree (dialog);
				//free(datastruct);
				fclose(datafile);
				GrayOn();
				return -1;
			}
#endif
	WINDOW *window = NULL;
	show_process_window (&window, "Save");


	//Add the new data at the end and close the file
	if ((fmanage(&datafile, ActivePath, FMF_FORMULA_FILE_VERSION, FILE_FORMULA_EXTENSION, &datastruct, sizeof(FORMULADATA), datanr, action, FMF_CLOSE)) < 0)
		{
			//free(datastruct);
			fclose(datafile);
			//Free the timer and the window created with show_process_window.
			OSVFreeTimer (1);
		  WinClose (window);
		  HeapFreePtr (window);

		  DlgMessage("thedb[4]", "Failed to save!", BT_OK, BT_CANCEL);
		  GrayOn();
			return -1;
		}



	//Free the timer and the window created with show_process_window.
	OSVFreeTimer (1);
  WinClose (window);
  HeapFreePtr (window);

	HeapFree (dialog);
	//free(datastruct);
	GrayOn();
	return 0;
}



