// C Source File
// Created 27.05.2006; 18:22:22

 /********************************************************************************
 ********************************************************************************
 * Programm name:		thedb - The handy education database
 * File name:				settings.c
 * Function name:		settings
 * Header file:			-
 *
 * Short Description:	Show the settings
 *
 * Description:
 *	-
 *
 ********************************************************************************
 *********************************************************************************/

#include <tigcclib.h>

#include "structures.h"
#include "global.h"
#include "calc.h"
#include "main_menu.h"

//

//

int settings (CONFSTRUCT *confstruct, int *CursorPosY)
{
	int lenght = 1;
	int gk = 0;

	main_menu_graphic();

			//the menu (light plane)
			GraySetAMSPlane (LIGHT_PLANE);
			DrawStr(8, MM_MENU0, "Settings", A_NORMAL);

			DrawStr(2, MM_MENU1, "Use keys:", A_NORMAL);
			DrawStr(4, MM_MENU2, "UP/DOWN", A_NORMAL);
			DrawStr(4, MM_MENU3, "LEFT/RIGHT", A_NORMAL);
			DrawStr(4, MM_MENU4, "ENTER/ESC", A_NORMAL);
			
			DrawChar(64, MM_SETTINGS_STARTUP, 0x12, A_NORMAL);
			DrawChar(LCD_WIDTH - 8, MM_SETTINGS_STARTUP, 0x11, A_NORMAL);
			if (confstruct->Startup == S_STARTUP_LIST)
				DrawStr(71, MM_SETTINGS_STARTUP, "Start with: list", A_NORMAL);
			else
				DrawStr(71, MM_SETTINGS_STARTUP, "Start with: menu", A_NORMAL);

			DrawChar(64, MM_SETTINGS_ARCHIVE, 0x12, A_NORMAL);
			DrawChar(LCD_WIDTH - 8, MM_SETTINGS_ARCHIVE, 0x11, A_NORMAL);
			if (confstruct->ArchiveFiles == S_ARCHIVE_YES)
				DrawStr(71, MM_SETTINGS_ARCHIVE, "Archive files: yes", A_NORMAL);
			else if (confstruct->ArchiveFiles == S_ARCHIVE_NO)
				DrawStr(71, MM_SETTINGS_ARCHIVE, "Archive files: no", A_NORMAL);
			else
				DrawStr(71, MM_SETTINGS_ARCHIVE, "Archive files: ?", A_NORMAL);


			DrawChar(64, MM_SETTINGS_BACKUP, 0x12, A_NORMAL);
			DrawChar(LCD_WIDTH - 8, MM_SETTINGS_BACKUP, 0x11, A_NORMAL);
			if (confstruct->MakeBackupCopy == S_BACKUP_YES)
				DrawStr(71, MM_SETTINGS_BACKUP, "Make backup copy: yes", A_NORMAL);
			else if (confstruct->MakeBackupCopy == S_BACKUP_NO)
				DrawStr(71, MM_SETTINGS_BACKUP, "Make backup copy: no", A_NORMAL);
			else
				DrawStr(71, MM_SETTINGS_BACKUP, "Make backup copy: ?", A_NORMAL);


			//the menu (dark plane)
			GraySetAMSPlane (DARK_PLANE);
			DrawStr(8, MM_MENU0, "Settings", A_NORMAL);

			DrawStr(71, MM_SETTINGS_STARTUP, "Start with:", A_NORMAL);
			DrawStr(71, MM_SETTINGS_ARCHIVE, "Archive files:", A_NORMAL);
			DrawStr(71, MM_SETTINGS_BACKUP, "Make backup copy:", A_NORMAL);






		//Show/remove the "cursor"
		DrawChar(64, *CursorPosY, 0x12, A_XOR);
		DrawChar(LCD_WIDTH - 8, *CursorPosY, 0x11, A_XOR);
		DrawPix(69, *CursorPosY + 2, A_XOR);
	
		switch (*CursorPosY)
			{
				case MM_SETTINGS_STARTUP:
						lenght = 22;
					break;
				case MM_SETTINGS_ARCHIVE:
						lenght = 21;
					break;
				case MM_SETTINGS_BACKUP:
						lenght = 2;
					break;
				default:
					break;
			}

		DrawLine(LCD_WIDTH - 8 - lenght, *CursorPosY + 2, LCD_WIDTH - 9, *CursorPosY + 2, A_XOR);
		
		
		//Wait for a keypress
		gk = ngetchx();
		
		//Exit the Programm, if ESC or ENTER was pressed
		if ((gk == KEY_ESC) || (gk == KEY_ENTER))
			{
				return -1;
			}
		else
			{
				switch (gk)
					{
						case KEY_DOWN:
								if ((*CursorPosY + 10) > MM_SETTINGS_BACKUP)
									{
										*CursorPosY = MM_SETTINGS_STARTUP;
										break;
									}

								*CursorPosY += 10;
							break;
						case KEY_UP:
								if ((*CursorPosY - 10) < MM_SETTINGS_STARTUP)
									{
										*CursorPosY = MM_SETTINGS_BACKUP;
										break;
									}

								*CursorPosY -= 10;
							break;
						case KEY_RIGHT:
						case KEY_LEFT:
								if (*CursorPosY == MM_SETTINGS_STARTUP)
									{
										if (confstruct->Startup == S_STARTUP_LIST)
											confstruct->Startup = 0;
										else if (confstruct->Startup == 0)
											confstruct->Startup = S_STARTUP_LIST;
									}
								else if (*CursorPosY == MM_SETTINGS_ARCHIVE)
									{
										if (confstruct->ArchiveFiles == S_ARCHIVE_YES)
											confstruct->ArchiveFiles = S_ARCHIVE_NO;
										else if (confstruct->ArchiveFiles == S_ARCHIVE_NO)
											confstruct->ArchiveFiles = S_ARCHIVE_YES;
									}
								else if (*CursorPosY == MM_SETTINGS_BACKUP)
									{
										if (confstruct->MakeBackupCopy == S_BACKUP_YES)
											confstruct->MakeBackupCopy = S_BACKUP_NO;
										else if (confstruct->MakeBackupCopy == S_BACKUP_NO)
											confstruct->MakeBackupCopy = S_BACKUP_YES;
									}
							break;
						default:
							break;
					}

			}



	return 1;
}


