// Header File
// Created 16.02.2006; 18:29:08

 /********************************************************************************
 ********************************************************************************
 * Programm name:		thedb - The handy education database
 * File name:				structures.h
 *
 * Short Description: The structures, and some definitions for the structures,
 *										used in this programm
 *
 * Description:
 *	-
 *
 ********************************************************************************
 *********************************************************************************/

//Configuration structure of the programm
typedef struct
	{
		char PathFormula[3][20];	//The paths to the current formula file
		int ActivePathFormula;		//Is the active path nr 0, 1 or 2?

		char PathText[3][20];			//The paths to the current text file
		int ActivePathText;				//Is the active path nr 0, 1 or 2?

		int ActiveForm;						//The active form (Formula or text)
		int ActiveList;						//The active list view (when ActiveForm is set to formula: NAME, FORMULA or DESC. When ActiveForm is set to text: TITLE, TEXT)
		int PosFormula[3];				//The position of the cursor block in the formula list view
		int PosText[3];						//The position of the cursor block in the text list view
		int StartFormula[3];			//The first entry, showed in the formula list view
		int StartText[3];					//The first entry, showed in the text list view

		char LastSearchString[21]; //The last search string, used in the list view.

		int exact_approx;					//Show the data in the 2D view exact or approximate
		int FontLargeSmall;				//Show the data in the 2D view with F_4x6 or F_6x8
		
		int Startup;							//The indicator, if the list view or the main menu should be showed when starting the programm
		int ArchiveFiles;					//Archive the datafiles (1) or not (0)
		int MakeBackupCopy;				//Make a backup copy of the active file (1) or not (0)

	} CONFSTRUCT;


//Data structure for formulas
#define MAXLEN_NAME				20
#define MAXLEN_FORMULA		50
#define MAXLEN_DESC				50
#define	MAXLEN_VARS				MAXLEN_FORMULA

typedef struct
	{
		char name[MAXLEN_NAME + 1];
		char formula[MAXLEN_FORMULA + 1];
		char desc[MAXLEN_DESC + 1];

	} FORMULADATA;


//Data structure for texts
#define MAXLEN_TITLE			20
#define MAXLEN_TEXT				100

typedef struct
	{
		char title[MAXLEN_TITLE + 1];
		char text[MAXLEN_TEXT + 1];

	} TEXTDATA;


//The lenght of the longest string variable in one of the structures
#define	MAXLEN_STR			101


